Index: code/trunk/src/orxonox/objects/pickup/BaseItem.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/BaseItem.cc	(revision 3068)
+++ code/trunk/src/orxonox/objects/pickup/BaseItem.cc	(revision 3073)
@@ -1,78 +1,108 @@
-/* has to be added to player
-   multimap<std::string, BaseItem*> Equipment;*/
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
 
+/**
+    @file
+    @brief Implementation of BaseItem (base-class for items/pickups).
+*/
 
-#include "OrxonoxStableHeaders.h"
 #include "BaseItem.h"
+
+#include "PickupCollection.h"
+
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "util/String.h"
 #include "objects/worldentities/pawns/Pawn.h"
-
 
 namespace orxonox
 {
-BaseItem::BaseItem(BaseObject* creator) : BaseObject(creator)
-{
-	RegisterObject(BaseItem);
+    /**
+        @brief Constructor. Registers the BaseItem.
+        @param creator Pointer to the object which created this item.
+    */
+    BaseItem::BaseItem(BaseObject* creator) : BaseObject(creator)
+    {
+        RegisterObject(BaseItem);
 
-	this->playerBaseClass_ = 0;
-}
+        this->setOwner(0);
+        this->setPickupIdentifier(this->getName());
+        this->setGUIImage("");
+        this->setGUIText("");
+    }
+    //! Deconstructor.
+    BaseItem::~BaseItem()
+    {
+    }
 
-BaseItem::~BaseItem()
-{
-}
+    /**
+        @brief XMLPort for BaseItem.
+        @param xmlelement Element of the XML-file.
+        @param mode XMLPort mode to use.
+    */
     void BaseItem::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(BaseItem, XMLPort, xmlelement, mode);
 
-        XMLPortParam(BaseItem, "playerclass", setPlayerBaseClassName, getPlayerBaseClassName, xmlelement, mode);
+        XMLPortParam(BaseItem, "guiText", setGUIText, getGUIText, xmlelement, mode);
+        XMLPortParam(BaseItem, "guiImage", setGUIImage, getGUIImage, xmlelement, mode);
     }
 
-bool BaseItem::addTo (Pawn* player)
-{
+    /**
+        @brief Method to add the item to a pawn.
+        @param pawn Pawn to which the item should get added.
+        @return Returns whether the pawn's PickupCollection accepted the item.
+    */
+    bool BaseItem::addTo(Pawn* pawn)
+    {
+        this->setOwner(pawn);
 
-	return player->getPickUp().insert(this);
-	/*if(checkSlot(player)==true)
-	player->pickUp.Equipment.insert ( std::pair<std::string, BaseItem*>(this->getName(),this) );
-	else
-	COUT(3) << "swap?" << std::endl;*/
+        if (pawn->getPickups().add(this))
+        {
+            COUT(3) << "Added '" << this->getPickupIdentifier() << "' item." << std::endl;
+            return true;
+        }
+        return false;
+    }
+    /**
+        @brief Removes the item from a pawn.
+        @param pawn Pawn from which to remove the item.
+        @return Returns whether the pawn's PickupCollection was able to locate and remove the item.
+    */
+    bool BaseItem::removeFrom(Pawn* pawn)
+    {
+        this->setOwner(0);
+
+        COUT(3) << "Removing '" << this->getPickupIdentifier() << "' item." << std::endl;
+
+        pawn->getPickups().remove(this, false);
+
+        return true;
+    }
+
+    const std::string& BaseItem::getGUIText() const { return this->guiText_; }
 }
-bool BaseItem::remove(Pawn* player)
-{
- 	/*if(player->pickUp.Equipment.find(this->getName())!= player->pickUp.Equipment.end())
- 	{
- 	std::multimap<std::string,BaseItem*>::iterator it;
- 	it=player->pickUp.Equipment.find(this->getName());
-  	player->pickUp.Equipment.erase (it);
-  	return true;
-  	}
-  	else
-  	return false;*/
-  	return player->getPickUp().erase(this);
-}
-bool BaseItem::checkSlot(Pawn* player)
-{
-	/*std::multimap<std::string,BaseItem*>::iterator it;
-	for ( it=player->getPickUp().getEquipment().begin() ; it != player->getPickUp().getEquipment().end(); it++ )
-	{
-	if((*it).second->playerBaseClass_==this->playerBaseClass_)
-		//das isch schmarre...machs mit isExactlyA(...)
-	return false;
-	}
-	return true;*/
-	return player->getPickUp().checkSlot(this);
-}
-void BaseItem::setPlayerBaseClassName(const std::string& name)
-{
-	this->playerBaseClass_ = ClassByString(name);
-}
-
-const std::string& BaseItem::getPlayerBaseClassName() const
-{
-	if (this->playerBaseClass_)
-		return this->playerBaseClass_->getName();
-	else
-		return BLANKSTRING;
-}
-}
Index: code/trunk/src/orxonox/objects/pickup/BaseItem.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/BaseItem.h	(revision 3068)
+++ code/trunk/src/orxonox/objects/pickup/BaseItem.h	(revision 3073)
@@ -1,37 +1,152 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Definition of BaseItem (base-class for items/pickups).
+*/
+
 #ifndef _BaseItem_H__
 #define _BaseItem_H__
 
-#include "core/BaseObject.h"
 #include "OrxonoxPrereqs.h"
 
+#include "core/BaseObject.h"
+
+// tolua_begin
 namespace orxonox
 {
-	class ShipEquipment;
+    /**
+        @brief
+            Base class for all items/pickups.
 
-	class _OrxonoxExport BaseItem : public BaseObject
-	{
-	public:
-	BaseItem( BaseObject* creator);
-	virtual ~BaseItem();
-	bool checkSlot(Pawn* player);
-	virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            Provides common methods to be used in derived classes.
+        @author
+            Daniel 'Huty' Haggenmueller
+    */
+    class _OrxonoxExport BaseItem
+// tolua_end
+        : public BaseObject
+// tolua_begin
+    {
+// tolua_end
+    public:
+        BaseItem(BaseObject* creator);
+        virtual ~BaseItem();
 
-	virtual bool pickedUp(Pawn* player) { return true; }
-	virtual bool dropped(Pawn* player) { return true; } //erst bei festen Items
-	bool remove(Pawn* player);
-	bool addTo(Pawn* player);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);  //!< XMLPort
 
-	inline void setPlayerBaseClass(Identifier* identifier)
-		{ this->playerBaseClass_ = identifier; }
-	inline Identifier* getPlayerBaseClass() const
-		{ return this->playerBaseClass_; }
+        /**
+            @brief Checks how many instances of this item can be carried at a time.
+            @return How many of this item can be carried.
+        */
+        virtual int getMaxCarryAmount() const
+            { return 1; }
 
-	private:
-	void setPlayerBaseClassName(const std::string& name);
-	const std::string& getPlayerBaseClassName() const;
+        bool addTo(Pawn* pawn);             //!< Add the item to a pawn.
+        bool removeFrom(Pawn* pawn);        //!< Removes the item from a pawn.
+        /**
+            @brief
+                Method invoked when the item gets picked up.
 
-	Identifier* playerBaseClass_;
-	};
-}
+                Has to be overridden for an item to work,
+                should contain a call to addTo().
+
+            @param pawn Pawn who picks up the item.
+            @return Returns whether the pawn was able to pick up the item.
+        */
+        virtual bool pickedUp(Pawn* pawn)
+            { return false; }
+        /**
+            @brief
+                Method invoked when the item is dropped from a player.
+
+                Should be overridden by derived classes,
+                should also contain a call to removeFrom().
+
+            @param pawn Pawn which dropped the item.
+            @return Returns whether the item was able to get dropped by the pawn.
+        */
+        virtual bool dropped(Pawn* pawn)
+            { return false; }
+
+        /**
+            @brief Gets the current owner of the pickup.
+            @return Returns the current owner.
+        */
+        inline Pawn* getOwner() const
+            { return this->owner_; }
+        /**
+            @brief Sets the owner of the pickup.
+            @param owner New owner for the pickup.
+        */
+        inline void setOwner(Pawn* owner)
+            { this->owner_ = owner; }
+
+        /**
+            @brief Gets the pickupIdentifier of the item.
+            @return Returns the pickupIdentifier of the item.
+            @see pickupIdentifier_
+        */
+        inline const std::string& getPickupIdentifier() const
+            { return this->pickupIdentifier_; }
+        /**
+            @brief Sets the pickupIdentifier for the item.
+            @param identifier New pickupIdentifier for the item.
+            @see pickupIdentifier_
+        */
+        inline void setPickupIdentifier(const std::string& identifier)
+            { this->pickupIdentifier_ = identifier; }
+
+        // GUI stuff
+        virtual const std::string& getGUIText() const; // tolua_export
+        inline void setGUIText(const std::string& text)
+            { this->guiText_ = text; }
+
+        virtual const std::string& getGUIImage() const
+            { return this->guiImage_; }
+        inline void setGUIImage(const std::string& image)
+            { this->guiImage_ = image; }
+    private:
+        Pawn* owner_;   //!< The current owner of the item.
+
+        /**
+            @brief
+                The pickupIdentifier of the item..
+
+                Usually set to the template name used by a PickupSpawner,
+                used to index items in the PickupCollection.
+        */
+        std::string pickupIdentifier_;
+
+        std::string guiText_;
+        std::string guiImage_;
+    }; // tolua_export
+} // tolua_export
 
 #endif /* _BaseItem_H__ */
Index: code/trunk/src/orxonox/objects/pickup/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/objects/pickup/CMakeLists.txt	(revision 3068)
+++ code/trunk/src/orxonox/objects/pickup/CMakeLists.txt	(revision 3073)
@@ -1,6 +1,13 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  BaseItem.cc
+  DroppedItem.cc
+  EquipmentItem.cc
+  ModifierPickup.cc
+  PassiveItem.cc
+  PickupCollection.cc
+  PickupInventory.cc
   PickupSpawner.cc
-  BaseItem.cc
-  Turbo.cc
-  ShipEquipment.cc
+  UsableItem.cc
 )
+
+ADD_SUBDIRECTORY(items)
Index: code/trunk/src/orxonox/objects/pickup/DroppedItem.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/DroppedItem.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/DroppedItem.cc	(revision 3073)
@@ -0,0 +1,96 @@
+#include "DroppedItem.h"
+
+#include "BaseItem.h"
+#include "objects/worldentities/pawns/Pawn.h"
+#include "objects/worldentities/Model.h"
+#include "objects/worldentities/Billboard.h"
+
+#include "core/CoreIncludes.h"
+#include "core/Core.h"
+
+namespace orxonox
+{
+    CreateFactory(DroppedItem);
+
+    DroppedItem::DroppedItem(BaseObject* creator) : StaticEntity(creator)
+    {
+        RegisterObject(DroppedItem);
+
+        this->triggerDistance_ = 20.0f;
+        this->timeToLive_ = 0;
+        this->item_ = 0;
+    }
+    DroppedItem::~DroppedItem()
+    {
+    }
+    void DroppedItem::tick(float dt)
+    {
+        if (this->item_)
+        {
+            for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); it++)
+            {
+                Vector3 distance = it->getWorldPosition() - this->getWorldPosition();
+                if (distance.length() < this->triggerDistance_)
+                    this->trigger(*it);
+            }
+        }
+    }
+    void DroppedItem::trigger(Pawn* pawn)
+    {
+        if (this->item_->pickedUp(pawn))
+        {
+            COUT(3) << "DroppedItem '" << this->item_->getPickupIdentifier() << "' picked up." << std::endl;
+            delete this;
+        }
+    }
+    void DroppedItem::createTimer()
+    {
+        if (this->timeToLive_ > 0)
+        {
+            ExecutorMember<DroppedItem>* exec = createExecutor(createFunctor(&DroppedItem::timerCallback));
+            this->timer_.setTimer(this->timeToLive_, false, this, exec, false);
+        }
+    }
+    void DroppedItem::timerCallback()
+    {
+        if (this->item_)
+        {
+            COUT(3) << "Delete DroppedItem with '" << this->item_->getPickupIdentifier() << "'" << std::endl;
+            delete this->item_;
+        }
+
+        delete this;
+    }
+
+    DroppedItem* DroppedItem::createDefaultDrop(BaseItem* item, const Vector3& position, const ColourValue& flareColour, float timeToLive)
+    {
+        DroppedItem* drop = new DroppedItem(item);
+        Model* model = new Model(item);
+        Billboard* billboard = new Billboard(item);
+        
+        model->setMeshSource("sphere.mesh");
+        model->setScale(3.0f);
+
+        billboard->setMaterial("Examples/Flare");
+        billboard->setColour(flareColour);
+        billboard->setScale(0.5f);
+
+        drop->setPosition(position);
+        drop->attach(model);
+        drop->attach(billboard);
+
+        drop->setItem(item);
+
+        drop->setTimeToLive(timeToLive);
+        drop->createTimer();
+
+        COUT(3) << "Created DroppedItem for '" << item->getPickupIdentifier() << "' at (" << position.x << "," << position.y << "," << position.z << ")." << std::endl;
+
+        return drop;
+    }
+    DroppedItem* DroppedItem::createDefaultDrop(BaseItem* item, Pawn* pawn, const ColourValue& flareColour, float timeToLive)
+    {
+        Vector3 after = pawn->getPosition() + pawn->getOrientation() * Vector3(0.0f, 0.0f, 50.0f);
+        return DroppedItem::createDefaultDrop(item, after, flareColour, timeToLive);
+    }
+}
Index: code/trunk/src/orxonox/objects/pickup/DroppedItem.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/DroppedItem.h	(revision 3073)
@@ -0,0 +1,86 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Definition of BaseItem (base-class for items/pickups).
+*/
+
+#ifndef _DroppedItem_H__
+#define _DroppedItem_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "objects/Tickable.h"
+#include "objects/worldentities/StaticEntity.h"
+#include "tools/Timer.h"
+
+namespace orxonox
+{
+    class BaseItem;
+    class Pawn;
+
+    class _OrxonoxExport DroppedItem : public StaticEntity, public Tickable
+    {
+    public:
+        DroppedItem(BaseObject* creator);
+        virtual ~DroppedItem();
+
+        void tick(float dt);
+        void trigger(Pawn* pawn);
+
+        static DroppedItem* createDefaultDrop(BaseItem* item, const Vector3& position, const ColourValue& flareColour = ColourValue(0.5f, 1.0f, 0.3f), float timeToLive = 0);
+        static DroppedItem* createDefaultDrop(BaseItem* item, Pawn* pawn, const ColourValue& flareColour = ColourValue(0.5f, 1.0f, 0.3f), float timeToLive = 0);
+
+        void createTimer();
+        void timerCallback();
+
+        inline float getTriggerDistance() const
+            { return this->triggerDistance_; }
+        inline void setTriggerDistance(float distance)
+            { this->triggerDistance_ = distance; }
+
+        inline BaseItem* getItem() const 
+            { return this->item_; }
+        inline void setItem(BaseItem* item)
+            { this->item_ = item; }
+
+        inline float getTimeToLive() const
+            { return this->timeToLive_; }
+        inline void setTimeToLive(float time)
+            { this->timeToLive_ = time; }
+    private:
+        float timeToLive_;
+        float triggerDistance_;
+        BaseItem* item_;
+
+        Timer<DroppedItem> timer_;
+    };
+}
+
+#endif /* _DroppedItem_H__ */
Index: code/trunk/src/orxonox/objects/pickup/EquipmentItem.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/EquipmentItem.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/EquipmentItem.cc	(revision 3073)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of EquipmentItem.
+*/
+
+#include "EquipmentItem.h"
+
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor. Registers the EquipmentItem.
+        @param creator Pointer to the object which created this item.
+    */
+    EquipmentItem::EquipmentItem(BaseObject* creator) : BaseItem(creator)
+    {
+        RegisterObject(EquipmentItem);
+    }
+    //! Deconstructor.
+    EquipmentItem::~EquipmentItem()
+    {
+    }
+}
Index: code/trunk/src/orxonox/objects/pickup/EquipmentItem.h
===================================================================
--- code/trunk/src/orxonox/objects/pickup/EquipmentItem.h	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/EquipmentItem.h	(revision 3073)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Definition of EquipmentItem (base-class for equipment-type items).
+*/
+
+#ifndef _EquipmentPickup_H__
+#define _EquipmentPickup_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "BaseItem.h"
+
+namespace orxonox
+{
+    /**
+        @brief Base class for all equipment-type items.
+        @author Daniel 'Huty' Haggenmueller
+    */
+    class _OrxonoxExport EquipmentItem : public BaseItem
+    {
+    public:
+        EquipmentItem(BaseObject* creator);
+        virtual ~EquipmentItem();
+    };
+}
+
+#endif /* _EquipmentPickup_H__ */
Index: code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc
===================================================================
--- code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc	(revision 3073)
+++ code/trunk/src/orxonox/objects/pickup/ModifierPickup.cc	(revision 3073)
@@ -0,0 +1,210 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Daniel 'Huty' Haggenmueller
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of ModifierPickup (temporary(?) pickup for testing).
+*/
+
+#include "ModifierPickup.h"
+#include "PickupCollection.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "core/Core.h"
+
+#include "objects/worldentities/pawns/Pawn.h"
+
+#include "util/Debug.h"
+
+namespace orxonox
+{
+    CreateFactory(ModifierPickup);
+
+    /**
+        @brief Constructor. Registers the ModifierPickup.
+        @param creator Pointer to the object which created this item.
+    */
+    ModifierPickup::ModifierPickup(BaseObject* creator) : PassiveItem(creator)
+    {
+        RegisterObject(ModifierPickup);
+
+        this->duration_ = 0.0f;
+    }
+    //! Deconstructor.
+    ModifierPickup::~ModifierPickup()
+    {
+    }
+    /**
+        @brief Method for loading information from a level file.
+        @param element XMLElement from which to read the data.
+        @param mode XMLPort mode to use.
+    */
+    void ModifierPickup::XMLPort(Element& element, XMLPort::Mode mode)
+    {
+        SUPER(ModifierPickup, XMLPort, element, mode);
+
+        XMLPortParam(ModifierPickup, "duration", setDuration, getDuration, element, mode);
+
+        XMLPortParamTemplate(ModifierPickup, "damageAdd", setAdditiveDamage, getAdditiveDamage, element, mode, float);
+        XMLPortParamTemplate(ModifierPickup, "damageMulti", setMultiplicativeDamage, getMultiplicativeDamage, element, mode, float);
+
+        XMLPortParamTemplate(ModifierPickup, "accelerationAdd", setAdditiveAcceleration, getAdditiveAcceleration, element, mode, float);
+        XMLPortParamTemplate(ModifierPickup, "accelerationMulti", setMultiplicativeAcceleration, getMultiplicativeAcceleration, element, mode, float);
+    }
+    /**
+        @brief
+            Invoked when a pawn picks up the pickup.
+
+            Adds the modifiers to the pawn and sets a timer (if effect is limited)
+            if the pickup could be added to the pawn's PickupCollection.
+
+        @param pawn Pawn which picked up the pickup.
+        @return Returns whether the pickup was able to be added to the pawn.
+    */
+    bool ModifierPickup::pickedUp(Pawn* pawn)
+    {
+        if (this->addTo(pawn))
+        {
+            std::map<ModifierType::Enum, float>::iterator it;
+
+            for (it = this->additiveModifiers_.begin(); it != this->additiveModifiers_.end(); it++)
+            {
+                pawn->getPickups().addAdditiveModifier((*it).first, (*it).second);
+            }
+
+            for (it = this->multiplicativeModifiers_.begin(); it != this->multiplicativeModifiers_.end(); it++)
+            {
+                pawn->getPickups().addMultiplicativeModifier((*it).first, (*it).second);
+            }
+
+            if (this->duration_ > 0.0f)
+            {
+                ExecutorMember<ModifierPickup>* executor = createExecutor(createFunctor(&ModifierPickup::timerCallback));
+                executor->setDefaultValues(pawn);
+                this->timer_.setTimer(this->duration_, false, this, executor);
+            }
+            
+            return true;
+        }
+        return false;
+    }
+    /**
+        @brief
+            Invoked when a pawn drops the pickup.
+
+            Removes the modifiers from the pawn if the pickup
+            was successfully removed from it's PickupCollection.
+
+        @param pawn Pawn which dropped the pickup.
+        @return Returns whether the pickup could be removed.
+    */
+    bool ModifierPickup::dropped(Pawn* pawn)
+    {
+        if (this->removeFrom(pawn))
+        {
+            std::map<ModifierType::Enum, float>::iterator it;
+
+            for (it = this->additiveModifiers_.begin(); it != this->additiveModifiers_.end(); it++)
+            {
+                pawn->getPickups().removeAdditiveModifier((*it).first, (*it).second);
+            }
+
+            for (it = this->multiplicativeModifiers_.begin(); it != this->multiplicativeModifiers_.end(); it++)
+            {
+                pawn->getPickups().removeMultiplicativeModifier((*it).first, (*it).second);
+            }
+            
+            if (this->timer_.getRemainingTime() > 0.0f)
+                this->timer_.stopTimer();
+
+            delete this;
+
+            return true;
+        }
+        return false;
+    }
+    /**
+        @brief Invoked when the timer finished, calls dropped().
+    */
+    void ModifierPickup::timerCallback(Pawn* pawn)
+    {
+        if (!this->dropped(pawn))
+            COUT(2) << "Failed to remove modifier pickup after the timer ran out!" << std::endl;
+    }
+    /**
+        @brief Gets the additive modifier of a given type.
+        @param type ModifierType for which to return the modifier.
+        @return Returns the additive modifier for type (or 0 if not exists).
+    */
+    float ModifierPickup::getAdditiveModifier(ModifierType::Enum type) const
+    {
+        std::map<ModifierType::Enum, float>::const_iterator it = this->additiveModifiers_.find(type);
+        if (it != this->additiveModifiers_.end())
+            return (*it).second;
+        else
+            return 0.0f;
+    }
+    /**
+        @brief Gets the multiplicative modifier of a given type.
+        @param type ModifierType for which to return the modifier.
+        @return Returns the multiplicative modifier for type (or 1 if not exists).
+    */
+    float ModifierPickup::getMultiplicativeModifier(ModifierType::Enum type) const
+    {
+        std::map<ModifierType::Enum, float>::const_iterator it = this->multiplicativeModifiers_.find(type);
+        if (it != this->multiplicativeModifiers_.end())
+            return (*it).second;
+        else
+            return 1.0f;
+    }
+    /**
+        @brief Gets the additive modifier of a given type.
+        @param type ModifierType for which to return the modifier.
+        @param value The new additive modifier for type.
+    */
+    void ModifierPickup::setAdditiveModifier(ModifierType::Enum type, float value)
+    {
+        if (this->additiveModifiers_.find(type) == this->additiveModifiers_.end())
+            this->additiveModifiers_.insert( std::pair<ModifierType::Enum, float>(type, value) );
+        else
+            this->additiveModifiers_[type] = value;
+    }
+    /**
+        @brief Gets the multiplicative modifier of a given type.
+        @param type ModifierType for which to return the modifier.
+        @param value The new multiplicative modifier for type.
+    */
+    void ModifierPickup::setMultiplicativeModifier(ModifierType::Enum type, float value)
+    {
+        if (this->multiplicativeModifiers_.find(type) == this->multiplicativeModifiers_.end())
+            this->multiplicativeModifiers_.insert( std::pair<ModifierType::Enum, float>(type, value) );
+        else
+            this->multiplicativeModifiers_[type] = value;
+    }
+}
